package global

import (
	"context"
	"electricity_bill_calc/config"
	"fmt"

	"github.com/rueian/rueidis"
)

var (
	RedisConn rueidis.Client
	Ctx       = context.Background()
)

func SetupRedisConnection() error {
	var err error
	RedisConn, err = rueidis.NewClient(rueidis.ClientOption{
		InitAddress: []string{fmt.Sprintf("%s:%d", config.RedisSettings.Host, config.RedisSettings.Port)},
		Password:    config.RedisSettings.Password,
		SelectDB:    config.RedisSettings.DB,
	})
	if err != nil {
		return err
	}
	pingCmd := RedisConn.B().Ping().Build()
	result := RedisConn.Do(Ctx, pingCmd)
	if result.Error() != nil {
		return result.Error()
	}
	return nil
}
